Bug 312241 - Unmounting busy NFS shares doesn't report error and gets removed from mtab
Unmounting busy NFS shares doesn't report error and gets removed from mtab
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: nfs-utils (Show other bugs)
8
All Linux
low Severity low
: ---
: ---
Assigned To: Steve Dickson
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-09-29 06:56 EDT by Andrew Parker
Modified: 2008-12-02 06:57 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-12-02 06:57:01 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Andrew Parker 2007-09-29 06:56:09 EDT
Description of problem:

If you umount a busy NFS share, no errors are reported.  In addition the entry
is removed from /etc/mtab, although entries are still listed in /proc/fs/nfsfs/

Version-Release number of selected component (if applicable):

nfs-utils-1.1.0-5.fc8
nfs-utils-lib-1.1.0-2.fc8
kernel-2.6.23-0.202.rc8.fc8

How reproducible:

Always

Steps to Reproduce:
1.   Mount a remote share
2.   cd to that share
3.   umount the share
  
Actual results:

No error.  Remote share remains mounted, but not listed in mtab or by df

Expected results:

Device busy error, entry remains in mtab 

Additional info:

Subsequently trying to umount the share reports the error although mtab/df
remain wrong.

[root@dell ~]# grep " nfs " /etc/mtab
[root@dell ~]# cat /proc/fs/nfsfs/*
NV SERVER   PORT USE HOSTNAME
NV SERVER   PORT DEV     FSID
[root@dell ~]# mount /mnt/remote-share
[root@dell ~]# grep " nfs " /etc/mtab
share.linuts.org:/share /mnt/remote-share nfs rw,addr=192.168.10.1 0 0
[root@dell ~]# cat /proc/fs/nfsfs/*
NV SERVER   PORT USE HOSTNAME
v3 c0a80a01  801   1 share.linuts.org
NV SERVER   PORT DEV     FSID
v3 c0a80a01  801 0:18    304:0
[root@dell ~]# cd /mnt/remote-share
[root@dell remote-share]# umount /mnt/remote-share    # THIS SHOULD FAIL, BUT
DOESN'T
[root@dell remote-share]# echo $?                     # THIS SHOULD BE NON-ZERO
0
[root@dell remote-share]# grep " nfs " /etc/mtab      # THIS SHOULD LIST THE SHARE
[root@dell remote-share]# cat /proc/fs/nfsfs/*
NV SERVER   PORT USE HOSTNAME
v3 c0a80a01  801   1 share.linuts.org
NV SERVER   PORT DEV     FSID
v3 c0a80a01  801 0:18    304:0
[root@dell remote-share]# umount /mnt/remote-share/   # THIS IS WHAT SHOULD HAVE
HAPPENED THE FIRST TIME
umount: /mnt/remote-share/: device is busy
[root@dell remote-share]# echo $?
1
[root@dell remote-share]# grep " nfs " /etc/mtab
[root@dell remote-share]# cat /proc/fs/nfsfs/*
NV SERVER   PORT USE HOSTNAME
v3 c0a80a01  801   1 share.linuts.org
NV SERVER   PORT DEV     FSID
v3 c0a80a01  801 0:18    304:0
[root@dell remote-share]# cd                  # UNMOUNTING WHEN NOT BUSY IS OK
[root@dell ~]# umount /mnt/remote-share/
[root@dell ~]# echo $?
0
[root@dell ~]# grep " nfs " /etc/mtab
[root@dell ~]# cat /proc/fs/nfsfs/*
NV SERVER   PORT USE HOSTNAME
NV SERVER   PORT DEV     FSID
Comment 1 Andrew Parker 2007-10-02 05:18:16 EDT
Problem exists with latest kernel (kernel-2.6.23-0.164.rc5.fc8), if that's relevant?
Comment 2 Steve Dickson 2008-01-24 16:13:25 EST
Assuming you are forcibly umount like "umount -l" it makes sense
the namespace is not being cleaned up probably.... 

Is this causing in type of instability?
Comment 3 Robert Hänel 2008-01-29 13:02:50 EST
This is a known bug in umount.nfs and there's already a patch provided in the
NFS mailing list (please see
<http://sourceforge.net/mailarchive/message.php?msg_id=20070924152931.3804.58445.stgit%40monet.1015granger.net>.
Comment 4 Bug Zapper 2008-11-26 02:52:51 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Note You need to log in before you can comment on or make changes to this bug.